﻿import { ElementRef, AfterContentInit, Renderer } from '@angular/core';
import { ExmplifySourceService } from "../services/source.service";
export declare class WindowRef {
    readonly nativeWindow: any;
}
export declare class ExemplifyDirective implements AfterContentInit {
    private winRef;
    private sourceService;
    target: any;
    source: string;
    customClass: string;
    externalSources: Array<ExternalSource>;
    usePrism: boolean;
    navStyle: string;
    keepInputs: boolean;
    visibility: boolean;
    texts: ExemplifyTexts;
    exemplifyId: any;
    escapeStrings: Array<string>;
    context: any;
    private copyMarkup;
    private hideMarkup;
    private hostElement;
    private element;
    private renderer;
    private window;
    private elementId;
    private code;
    private pre;
    private codeP;
    private parser;
    private activeItem;
    private activeListeners;
    private prism;
    private copyContent;
    private lastClass;
    private toggleState;
    private defaultTexts;
    private escapeAngularDirectives;
    constructor(el: ElementRef, renderer: Renderer, winRef: WindowRef, sourceService: ExmplifySourceService);
    /**
     * Copy to clipboard
     * @param {string} text - text to be copied to clipboard.
     */
    private copyToClipboard;
    ngAfterContentInit(): void;
    private showCode;
    private addLink;
    private addHide;
    private addCopy;
    private getHtmlMarkup;
    private addCodeContainer;
    private removeListeners;
    private removeActiveClass;
    private toggleVisibility;
    /**
     *  Extend object function.
     */
    private extend;
    ngOnDestroy(): void;
}
export interface ExternalSource {
    src: string;
    name: string;
    language?: string;
}
export interface ExemplifyTexts {
    heading?: string;
    markup?: string;
    copy?: string;
    show?: string;
    hide?: string;
}
