﻿"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("@angular/core");
var core_3 = require("@angular/core");
var source_service_1 = require("../services/source.service");
var rxjs_1 = require("rxjs");
function _window() {
    // return the global native browser window object
    return window;
}
var WindowRef = (function () {
    function WindowRef() {
    }
    Object.defineProperty(WindowRef.prototype, "nativeWindow", {
        get: function () {
            return _window();
        },
        enumerable: true,
        configurable: true
    });
    return WindowRef;
}());
WindowRef.decorators = [
    { type: core_3.Injectable },
];
/** @nocollapse */
WindowRef.ctorParameters = function () { return []; };
exports.WindowRef = WindowRef;
var ExemplifyDirective = (function () {
    function ExemplifyDirective(el, renderer, winRef, sourceService) {
        this.winRef = winRef;
        this.sourceService = sourceService;
        this.source = 'element';
        this.usePrism = true;
        this.navStyle = 'inline';
        this.keepInputs = false;
        this.visibility = false;
        this.escapeStrings = [];
        this.activeListeners = [];
        this.defaultTexts = {
            heading: "Code:",
            markup: "markup",
            copy: "Copy",
            show: "Show",
            hide: "Hide",
        };
        this.escapeAngularDirectives = [
            '*ngIf', '*ngFor', '*ngPluralCase', '*ngSwitchCase', '*ngSwitchDefault', 'ngClass', 'ngPlural', 'ngStyle', 'ngSwitch', 'ngTemplateOutlet', '[ngIf]', '[ngFor]', '[ngForOf]', '[ngPluralCase]', '[ngSwitchCase]', '[ngSwitchDefault]', 'ngModel'
        ];
        /**
         * Copy to clipboard
         * @param {string} text - text to be copied to clipboard.
         */
        this.copyToClipboard = function (text) {
            if (this.window.clipboardData && this.window.clipboardData.setData) {
                // IE specific code path to prevent textarea being shown while dialog is visible.
                return this.window.clipboardData.setData("Text", text);
            }
            else if (document.queryCommandSupported && document.queryCommandSupported("copy")) {
                var textarea = document.createElement("textarea");
                textarea.textContent = text;
                textarea.style.position = "fixed"; // Prevent scrolling to bottom of page in MS Edge.
                document.body.appendChild(textarea);
                textarea.select();
                try {
                    return document.execCommand("copy"); // Security exception may be thrown by some browsers.
                }
                catch (ex) {
                    console.warn("Copy to clipboard failed.", ex);
                    return false;
                }
                finally {
                    document.body.removeChild(textarea);
                }
            }
        };
        this.showCode = function (code, language, forceShow) {
            if (language === void 0) { language = 'markup'; }
            this.copyContent = code;
            if (this.usePrism && this.prism) {
                // remove last used class name (needed to clear class)
                if (this.lastClass) {
                    this.renderer.setElementClass(this.pre, 'language-' + this.lastClass, false);
                    this.renderer.setElementClass(this.code, 'language-' + this.lastClass, false);
                }
                // add classes to element
                this.renderer.setElementClass(this.pre, 'language-' + language, true);
                this.renderer.setElementClass(this.code, 'language-' + language, true);
                this.lastClass = language;
                switch (language) {
                    case 'typescript':
                    case 'javascript':
                    case 'js':
                        language = 'js';
                        break;
                    case 'css':
                        language = 'css';
                        break;
                    default:
                        language = 'markup';
                        break;
                }
                this.code.innerHTML = this.prism.highlight(code, this.prism.languages[language]);
            }
            else {
                this.renderer.setText(this.codeP, code);
            }
            this.toggleVisibility(this.pre, forceShow ? forceShow : this.visibility);
        };
        this.addLink = function (hostElement, name, code, language) {
            var _this = this;
            /** Create link for toggling markup */
            var listItem = this.renderer.createElement(hostElement, 'li');
            this.renderer.setElementClass(listItem, 'nav-item', true);
            var renderElement = this.renderer.createElement(listItem, 'a');
            this.renderer.createText(renderElement, name);
            this.renderer.setElementAttribute(renderElement, 'href', '#');
            this.renderer.setElementClass(renderElement, 'nav-link', true);
            this.renderer.setElementClass(renderElement, 'exemplify-' + name.toLowerCase().replace(/[ ._]/g, '-'), true);
            if (this.activeListeners.length === 0) {
                if (this.visibility) {
                    this.renderer.setElementClass(renderElement, 'active', true);
                }
                this.activeItem = renderElement;
            }
            /** Add click listener */
            var listener = this.renderer.listen(renderElement, 'click', function (event) {
                _this.removeActiveClass();
                _this.renderer.setElementClass(renderElement, 'active', true);
                _this.showCode(code, language, true);
                _this.activeItem = renderElement;
                event.preventDefault();
            });
            this.activeListeners.push(listener);
            return renderElement;
        };
        this.addHide = function (hostElement, navElement) {
            var _this = this;
            /** Create link for toggling markup */
            this.toggleState = this.renderer.createElement(navElement, 'a');
            var toggleState = this.renderer.createText(this.toggleState, this.texts.hide);
            this.renderer.setElementAttribute(this.toggleState, 'href', '#');
            this.renderer.setElementClass(this.toggleState, 'exemplify-hide', true);
            /** Add click listener for toggling markup example */
            this.hideMarkup = this.renderer.listen(this.toggleState, 'click', function (event) {
                event.preventDefault();
                //let content = this.parser.parseFromString(this.code.innerHTML,"text/html").body.childNodes[0].textContent;
                _this.toggleVisibility(toggleState);
            });
            this.activeListeners.push(this.hideMarkup);
        };
        this.addCopy = function (hostElement, navElement) {
            var _this = this;
            /** Create link for copying markup */
            var copy = this.renderer.createElement(navElement, 'a');
            this.renderer.createText(copy, this.texts.copy);
            this.renderer.setElementAttribute(copy, 'href', '#');
            this.renderer.setElementClass(copy, 'exemplify-copy', true);
            /** Add click listener for copying markup example */
            this.copyMarkup = this.renderer.listen(copy, 'click', function (event) {
                event.preventDefault();
                //let content = this.parser.parseFromString(this.code.innerHTML,"text/html").body.childNodes[0].textContent;
                _this.copyToClipboard(_this.copyContent);
            });
            this.activeListeners.push(this.copyMarkup);
        };
        this.getHtmlMarkup = function () {
            /** Create markup example */
            try {
                if (!this.context) {
                    console.log('No context set');
                }
                var markupExampleCode = Reflect.getMetadata('annotations', this.context.constructor);
                if (this.elementId) {
                    markupExampleCode = this.parser.parseFromString(markupExampleCode[0].template, "text/html").getElementById(this.elementId);
                }
                else if (this.exemplifyId) {
                    var selector = '[exemplify="' + this.exemplifyId + '"]';
                    var content = this.parser.parseFromString(markupExampleCode[0].template, "text/html").querySelectorAll(selector);
                    if (content.length > 1) {
                        console.log('Exemplify warning! Multiple elements are using: "' + this.exemplifyId + '" as a identifier for the example, it should be a unique id. Returning first match.');
                    }
                    markupExampleCode = content[0];
                }
                else {
                    console.log('Exemplify warning! No id set for example element, returning first match.');
                    markupExampleCode = this.parser.parseFromString(markupExampleCode[0].template, "text/html").querySelectorAll('[exemplify]')[0];
                }
                if (typeof markupExampleCode === 'undefined') {
                    console.log("Exemplify warning! Can't show example as the component holding the markup couldn't be found!");
                    return;
                }
                if (this.keepInputs !== true) {
                    markupExampleCode.removeAttribute("exemplify");
                    markupExampleCode.removeAttribute("id");
                    markupExampleCode.removeAttribute("[externalsources]");
                    markupExampleCode.removeAttribute("[source]");
                    markupExampleCode.removeAttribute("[target]");
                    markupExampleCode.removeAttribute("[customclass]");
                    markupExampleCode.removeAttribute("[navstyle]");
                    markupExampleCode.removeAttribute("[useprism]");
                    markupExampleCode.removeAttribute("[escapestrings]");
                    markupExampleCode.removeAttribute("[show]");
                    markupExampleCode.removeAttribute("[context]");
                }
                /** Add markup content */
                var markupExampleString = void 0;
                switch (this.source) {
                    case 'child':
                        markupExampleString = markupExampleCode.innerHTML;
                        break;
                    default:
                        markupExampleString = markupExampleCode.outerHTML;
                        break;
                }
                if (this.keepInputs === true) {
                    // keep original format ie. avoid attributes being transformed into lowercase
                    markupExampleString = markupExampleString.replace(/\[keepinputs]=/, '[keepInputs]=').replace(/\[externalsources]=/, '[externalSources]=').replace(/\[customclass]=/, '[customClass]=').replace(/\[navstyle]=/, '[navStyle]=').replace(/\[escapestrings]=/, '[escapeStrings]=');
                }
                if (this.escapeStrings) {
                    // loop through items to and reset their casing, useful for inputs that will be converted to lower case otherwise
                    for (var i = 0; i < this.escapeStrings.length; i++) {
                        var lower = new RegExp('\\' + this.escapeStrings[i].toLowerCase(), "g");
                        markupExampleString = markupExampleString.replace(lower, this.escapeStrings[i]);
                    }
                }
                // remove empty ="" form generated markup
                markupExampleString = markupExampleString.replace(/=""/g, '');
                return markupExampleString;
            }
            catch (error) {
                console.log(error);
                return "";
            }
        };
        this.addCodeContainer = function (hostElement) {
            this.pre = this.renderer.createElement(hostElement, 'pre');
            this.code = this.renderer.createElement(this.pre, 'code');
            this.renderer.setElementClass(this.pre, 'markup-example', true);
            this.codeP = this.renderer.createText(this.code, '');
            this.showCode(this.getHtmlMarkup());
        };
        this.removeListeners = function () {
            for (var i = 0; i < this.activeListeners.length; i++) {
                this.activeListeners[i]();
            }
        };
        this.removeActiveClass = function () {
            if (this.activeItem) {
                this.renderer.setElementClass(this.activeItem, 'active', false);
            }
        };
        this.toggleVisibility = function (element, forceShow) {
            if (forceShow) {
                this.renderer.setElementStyle(this.pre, 'display', 'block');
                this.toggleState.innerHTML = this.texts.hide;
                this.renderer.setElementClass(this.toggleState, 'exemplify-visible', true);
                this.visibility = true;
                return;
            }
            else if (forceShow === false) {
                this.renderer.setElementStyle(this.pre, 'display', 'none');
                this.toggleState.innerHTML = this.texts.show;
                this.renderer.setElementClass(this.toggleState, 'exemplify-visible', false);
                this.visibility = false;
                return;
            }
            if (this.visibility) {
                this.removeActiveClass();
                this.renderer.setElementStyle(this.pre, 'display', 'none');
                this.renderer.setElementClass(this.toggleState, 'exemplify-visible', false);
            }
            else {
                if (this.activeItem) {
                    this.renderer.setElementClass(this.activeItem, 'active', true);
                }
                this.renderer.setElementStyle(this.pre, 'display', 'block');
                this.renderer.setElementClass(this.toggleState, 'exemplify-visible', true);
            }
            this.visibility = !this.visibility;
            this.renderer.setText(element, this.visibility ? this.texts.hide : this.texts.show);
        };
        /**
         *  Extend object function.
         */
        this.extend = function (a, b) {
            for (var key in b)
                if (b.hasOwnProperty(key))
                    a[key] = b[key];
            return a;
        };
        this.hostElement = el.nativeElement;
        this.renderer = renderer;
        this.window = winRef.nativeWindow;
        this.elementId = this.hostElement.getAttribute("id");
        this.parser = new DOMParser();
        this.prism = winRef.nativeWindow.Prism;
    }
    ExemplifyDirective.prototype.ngAfterContentInit = function () {
        var _this = this;
        if (null == this.context)
            throw new Error("Input 'context' is required, add [context]=\"this\" to set example context to current component.");
        this.texts = this.extend(this.defaultTexts, this.texts);
        // add angular directives to the list of strings to escape
        (_a = this.escapeStrings).push.apply(_a, this.escapeAngularDirectives);
        /** Get host element */
        var hostElement;
        if (this.target) {
            hostElement = this.renderer.createElement(this.target, 'div');
        }
        else {
            hostElement = this.renderer.createElement(this.hostElement, 'div');
        }
        this.renderer.setElementClass(hostElement, 'exemplify-wrapper', true);
        if (this.customClass) {
            this.renderer.setElementClass(hostElement, this.customClass, true);
        }
        /** create div element to hold heading, hide/show and copy */
        var func = this.renderer.createElement(hostElement, 'div');
        this.renderer.setElementClass(func, ('exemplify-bar'), true);
        var funcSpan = this.renderer.createElement(func, 'span');
        this.renderer.createText(funcSpan, this.texts.heading);
        this.renderer.setElementClass(funcSpan, ('exemplify-label'), true);
        if (this.externalSources) {
            /** create nav element to hold links */
            var nav_1 = this.renderer.createElement(hostElement, 'ul');
            this.renderer.setElementClass(nav_1, ('nav'), true);
            this.renderer.setElementClass(nav_1, ('nav-' + this.navStyle), true);
            /** Create link for toggling markup */
            this.addLink(nav_1, this.texts.markup, this.getHtmlMarkup());
            var links = [];
            var _loop_1 = function (i) {
                links.push(this_1.sourceService.getSource(this_1.externalSources[i].src));
                this_1.sourceService.getSource(this_1.externalSources[i].src)
                    .subscribe(function (code) {
                    _this.addLink(nav_1, _this.externalSources[i].name, code, _this.externalSources[i].language ? _this.externalSources[i].language : 'typescript');
                });
            };
            var this_1 = this;
            for (var i = 0; i < this.externalSources.length; i++) {
                _loop_1(i);
            }
            // wait until all sources have loaded...
            rxjs_1.Observable.forkJoin(links).subscribe(function (res) {
                _this.addCopy(hostElement, func);
                _this.addHide(hostElement, func);
                // ...add code container
                _this.addCodeContainer(hostElement);
            });
        }
        else {
            this.addCopy(hostElement, func);
            this.addHide(hostElement, func);
            // ...add code container
            this.addCodeContainer(hostElement);
        }
        var _a;
    };
    ExemplifyDirective.prototype.ngOnDestroy = function () {
        /** Remove click listeners */
        this.removeListeners();
    };
    return ExemplifyDirective;
}());
ExemplifyDirective.decorators = [
    { type: core_1.Directive, args: [{
                selector: '[exemplify]'
            },] },
];
/** @nocollapse */
ExemplifyDirective.ctorParameters = function () { return [
    { type: core_1.ElementRef, },
    { type: core_1.Renderer, },
    { type: WindowRef, },
    { type: source_service_1.ExmplifySourceService, },
]; };
ExemplifyDirective.propDecorators = {
    'target': [{ type: core_2.Input },],
    'source': [{ type: core_2.Input },],
    'customClass': [{ type: core_2.Input },],
    'externalSources': [{ type: core_2.Input },],
    'usePrism': [{ type: core_2.Input },],
    'navStyle': [{ type: core_2.Input },],
    'keepInputs': [{ type: core_2.Input },],
    'visibility': [{ type: core_2.Input, args: ['show',] },],
    'texts': [{ type: core_2.Input },],
    'exemplifyId': [{ type: core_2.Input, args: ['exemplify',] },],
    'escapeStrings': [{ type: core_2.Input },],
    'context': [{ type: core_2.Input },],
};
exports.ExemplifyDirective = ExemplifyDirective;
//# sourceMappingURL=exemplify.directive.js.map