﻿"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
var rxjs_1 = require("rxjs");
require("rxjs/Rx");
var ExmplifySourceService = (function () {
    function ExmplifySourceService(http) {
        this.http = http;
    }
    ExmplifySourceService.prototype.getSource = function (src) {
        return this.http.get(src)
            .map(function (res) { return res.text(); })
            .catch(this.handleError);
    };
    ExmplifySourceService.prototype.handleError = function (error) {
        var errMsg;
        if (error instanceof http_1.Response) {
            var body = error.json() || '';
            var err = body.error || JSON.stringify(body);
            errMsg = error.status + " - " + (error.statusText || '') + " " + err;
        }
        else {
            errMsg = error.message ? error.message : error.toString();
        }
        return rxjs_1.Observable.throw(errMsg);
    };
    return ExmplifySourceService;
}());
ExmplifySourceService.decorators = [
    { type: core_1.Injectable },
];
/** @nocollapse */
ExmplifySourceService.ctorParameters = function () { return [
    { type: http_1.Http, },
]; };
exports.ExmplifySourceService = ExmplifySourceService;
//# sourceMappingURL=source.service.js.map